--- D:\Program Files\Windows CE Tools\wce420\POCKET PC 2003\Samples\Win32\enroll.orig\enroll.h	Fri Feb 21 18:06:40 2003
+++ D:\Program Files\Windows CE Tools\wce420\POCKET PC 2003\Samples\Win32\crtimprt\enroll.h	Fri Dec 26 13:01:52 2003
@@ -17,8 +17,8 @@
 #define OUTPUT_MAX_LEN 10000
 #define BUILD_STRING(s,a)  _sntprintf(tHoldPrintString ,OUTPUT_MAX_LEN-1, _T(s), a);
 #if 1
-	#define OUTPUT(s) if(lpMessageBox) lpMessageBox(0,_T(s),L"Enrollment Tool",MB_OK)
-	#define OUTPUT_1_ARG(s,a)if(lpMessageBox) {BUILD_STRING(s,a); lpMessageBox(0,tHoldPrintString,L"Enrollment Tool",MB_OK);}
+	#define OUTPUT(s) if(lpMessageBox) lpMessageBox(0,_T(s),L"Certificate Import Utility",MB_OK)
+	#define OUTPUT_1_ARG(s,a)if(lpMessageBox) {BUILD_STRING(s,a); lpMessageBox(0,tHoldPrintString,L"Certificate Import Utility",MB_OK);}
 #endif  
 
 #if 0
--- D:\Program Files\Windows CE Tools\wce420\POCKET PC 2003\Samples\Win32\enroll.orig\enroll.cpp	Fri Feb 21 18:06:40 2003
+++ D:\Program Files\Windows CE Tools\wce420\POCKET PC 2003\Samples\Win32\crtimprt\enroll.cpp	Fri Dec 26 18:40:21 2003
@@ -16,6 +16,8 @@
 #include <string.h>
 #include "wininet_bridge.h"
 #include "enroll.h"
+#include <shlobj.h>
+#pragma comment(lib, "ceshell.lib")
 
 TCHAR tHoldPrintString[OUTPUT_MAX_LEN]; // Used when we're doing the output of one arg.
 TCHAR tHoldForOuput[OUTPUT_MAX_LEN]; //Global Variable used for debugging.
@@ -27,7 +29,7 @@
 #endif 
 
 // From crypt_web.cpp
-BOOL CreateKeyAndGetContext  (CRYPT_KEY_PROV_INFO *pKeyProvInfo, HCRYPTPROV*  phCryptProv) ;
+BOOL CreateKeyAndGetContext  (CRYPT_KEY_PROV_INFO *pKeyProvInfo, HCRYPTPROV*  phCryptProv, TCHAR *gKeyFile) ;
 BOOL GenerateCertRequest(HCRYPTPROV hCryptProv,CRYPT_KEY_PROV_INFO *pKeyProvInfo,char **pB64CertReq);
 int  SendCertRequestToWebServer(TCHAR *gServer ,TCHAR *page, TCHAR *userName, TCHAR *password, char * B64CertReq);
 DWORD Base64DecodeExA( IN CHAR const *pchIn, IN DWORD cchIn, OUT BYTE *pbOut, OUT DWORD *pcbOut, OUT DWORD *pchConsumed);
@@ -51,6 +53,8 @@
 static const TCHAR  defPassword[] = _T(""); 
 static const TCHAR  defCertAttribs[] = _T(""); 
 static const TCHAR  defCertTemplate[] = _T("ClientAuth"); 
+static const TCHAR  defCertFileName[] = _T("usercrt.p7b");
+static const TCHAR  defKeyFileName[] = _T("userkey.pvk");
 
 
 //
@@ -58,6 +62,7 @@
 // Shared between DoEnroll and SetOptions.
 //
 #define MAX_SIZE 255
+#define MAX_BUFSIZE 65536
 static CRYPT_KEY_PROV_INFO gKeyProvInfo;
 static TCHAR  gCertStore[MAX_SIZE] ; 
 static TCHAR  gServer[MAX_SIZE];
@@ -70,6 +75,8 @@
 static TCHAR  gDeprecated[MAX_SIZE]; //Used to store deprecated Values
 static TCHAR  gCertTemplate[MAX_SIZE];
 static DWORD  gCertPickupChain;
+static TCHAR  gCertFile[MAX_PATH];
+static TCHAR  gKeyFile[MAX_PATH];
 
 // Used when setting params from file.
 // These are pointed to when data is needed for keyProvInfo string
@@ -94,15 +101,18 @@
 	HCRYPTPROV hCryptProv=0;
 	TCHAR certPickupPage[MAX_PATH+1];
     certPickupPage[MAX_PATH]=0; // Terminate the string
-
-	bWorked = 	CreateKeyAndGetContext(&gKeyProvInfo,&hCryptProv);
+	int filesize=0;
+	FILE *hSource=NULL;
+	int myerror=0;
+	
+	bWorked = 	CreateKeyAndGetContext(&gKeyProvInfo,&hCryptProv, gKeyFile);
 	if(!bWorked || !hCryptProv)
 	{
 	  OUTPUT("CreateKeyAndGetContext Failed\n");
 	  goto done;
-  }
-
+	}
 
+/* We don't need a certificate request or web enrollment!
 	bWorked = GenerateCertRequest(hCryptProv,&gKeyProvInfo,&B64CertReq);
 
 	if( !bWorked || !B64CertReq)
@@ -145,7 +155,25 @@
 	  OUTPUT("GetCertFromWebServer Failed\n");
 	  goto done;
   }
+*/
+	
+    // Read file with certificate(s) into array
+	if(!(hSource = _tfopen(gCertFile,_T("rb")))) 
+	{
+		OUTPUT_1_ARG("Could not open cert file %s\n", gCertFile);
+		goto done;
+	}
 
+	B64Cert=(char *)malloc(MAX_BUFSIZE);
+	memset(B64Cert, 0, MAX_BUFSIZE);
+	filesize = fread(B64Cert, sizeof(char), MAX_BUFSIZE-1, hSource);
+	if (filesize <= 0)
+	{
+		myerror=GetLastError();
+		OUTPUT_1_ARG("Could not read certificate file [%x] \n",myerror);
+		goto done;
+	}
+	
 	// Handles Both Chains and Certs
 	// This also sets the smart card options
 	// 
@@ -159,6 +187,7 @@
 
 	OUTPUT("Cert Has Been Added Succesfully\n");
 done:
+	if (hSource) fclose(hSource);
 	if (B64CertReq) free(B64CertReq);
 	if (PutRequest) free(PutRequest);
 	if (B64Cert) free(B64Cert);
@@ -244,11 +273,12 @@
 BOOL  SetOptions (TCHAR *PassedInFileName)
 {
 	TCHAR *tFileName ;
-
+	BOOL bServerFound=0; // Set to true when server field is set.
+	
 	///////////////////////////////
 	// Set the default options.
 	//////////////////////////////
-	gKeyProvInfo.pwszContainerName = L"enroll"; 
+	gKeyProvInfo.pwszContainerName = L"crtimprt"; 
 	gKeyProvInfo.pwszProvName = 0; 
 	gKeyProvInfo.dwProvType = PROV_RSA_FULL;
 	gKeyProvInfo.dwFlags = 0; 
@@ -266,23 +296,38 @@
 	_tcscpy(gCertAttribs,defCertAttribs);
 	_tcscpy(gCertTemplate,defCertTemplate);
 
+	// By default, look for the private key and certificate files
+	// in the My Documents folder in main memory.
+	//
+	// Find "My Documents" folder (actual name depends on PPC language version).
+	if (!SHGetDocumentsFolder(_T("\\"),gCertFile))
+	{
+		// Fallback to the English default
+		_tcscpy(gCertFile, _T("\\My Documents"));
+	}
+	// Append trailing slash
+	_tcscat(gCertFile, _T("\\"));
+	// Copy the same path to gKeyfile.
+	_tcscpy(gKeyFile, gCertFile);
+	// Append private key and certificate file names.
+	_tcscat(gCertFile,defCertFileName);
+	_tcscat(gKeyFile,defKeyFileName);
+
+	_tcscpy(gKeyContainerName, _T("crtimprt"));
+
 
 	if (PassedInFileName && _tcslen(PassedInFileName))  tFileName = PassedInFileName;
 	else return TRUE;
 
 	FILE* fOpt = _tfopen (tFileName,_T("r"));
-	if(!fOpt)
-	{
-	  _tprintf(_T("Unable to open Option File[%s] -Fatal since Can't Get a Server\n"),tFileName);
-	  return FALSE;
-    }
-
+	if(!fOpt) goto done1;
+	
 	// While we have data.
 	char MaxLine[MAX_OPTION_LINE];
 
     MaxLine[sizeof(MaxLine)-1]=0;// Null Terminate the buffer
 
-	BOOL bServerFound=0; // Set to true when server field is set.
+
 
 	while ( fgets (MaxLine,sizeof(MaxLine)-1,fOpt))
 	{
@@ -293,6 +338,8 @@
 
         // Get the String Options.
         else if (getString(MaxLine,"USERNAME=",gUserName));
+		else if (getString(MaxLine,"KEY_FILE=",gKeyFile));
+		else if (getString(MaxLine,"CERT_FILE=",gCertFile));
         else if (getString(MaxLine,"PASSWORD=",gPassword)) ;
         else if (getString(MaxLine,"CERT_STORE=",gCertStore));
         else if (getString(MaxLine,"SERVER=",gServer)) bServerFound=TRUE;
@@ -327,12 +374,16 @@
         }
     }
 
+	/*
 	if (!bServerFound) 
 	{
 	  OUTPUT( "SERVER not set in config file. This is a Fatal Error \n");
 	  return FALSE;
     }
+	*/
 	fclose(fOpt);
+
+done1:
 	return TRUE;
 }
 
@@ -352,13 +403,15 @@
     {
         lpMessageBox = (PMessageBox ) GetProcAddress(coreDll,_T("MessageBoxW"));
     }
-    // Must have Wininet
+
+    /* We do not require Wininet
     HINSTANCE winInet =  SetupWinInet();
     if (!winInet)
     {
         OUTPUT("LoadLibrary failed to load WinInet");
         goto done;
     }
+	*/
 
     if (!_tcsncicmp(pCmdLine,_T("-s"),2))
     {
@@ -375,6 +428,7 @@
     {
         // We're in diagnostics mode.
         OUTPUT("Entering Diagnostics Mode:\n");
+		/* 
         OUTPUT("Checking For NTLMSSP:\n");
         if (!(winInet = LoadLibrary(_T("ntlmssp.dll"))))
         {
@@ -385,6 +439,7 @@
             OUTPUT("NTLMSSP found!\n");
             OUTPUT("Everything looks good.\n");
         }
+		*/
         goto done;
     }
     else if (!_tcsncicmp(pCmdLine,_T(""),1))
@@ -393,6 +448,7 @@
         DWORD dwLen;
 
         tExecPath[MAX_PATH]=0;// Null terminate the string
+		memset(tExecPath, 0, MAX_PATH-1);
 
         // If nothing passed in try to read <exename>.cfg in dir our exe lives in.
         // Usually this will be enroll.cfg
@@ -435,7 +491,7 @@
     DoEnroll();  
 
 done:
-    if (winInet) FreeLibrary(winInet);
+    /* if (winInet) FreeLibrary(winInet); */
     if (coreDll) FreeLibrary(coreDll);
     return 0;
 }
--- D:\Program Files\Windows CE Tools\wce420\POCKET PC 2003\Samples\Win32\enroll.orig\crypt_web.cpp	Fri Feb 21 18:06:40 2003
+++ D:\Program Files\Windows CE Tools\wce420\POCKET PC 2003\Samples\Win32\crtimprt\crypt_web.cpp	Sat Dec 27 23:30:58 2003
@@ -17,13 +17,17 @@
 #include <wincrypt.h>
 #include <stdio.h>
 #include <tchar.h>
+#include <shlobj.h>
 #include "base64.h"
 #include <string.h>
 #include "wininet_bridge.h"
 #include "enroll.h"
+#pragma comment(lib, "ceshell.lib")
 
 #define MY_ENCODING_TYPE  (PKCS_7_ASN_ENCODING | X509_ASN_ENCODING)
 DWORD Base64DecodeExA( IN CHAR const *pchIn, IN DWORD cchIn, OUT BYTE *pbOut, OUT DWORD *pcbOut, OUT DWORD *pchConsumed);
+
+/* We don't need WinInet or web parsing!
 //
 // We'll Dynamically Link to WinInet
 // 
@@ -102,7 +106,7 @@
 	}
 	return Out-Start;
 }
-
+*/
 
 void HandleError(char *s)
 {
@@ -421,9 +425,8 @@
 	// Open the cert store.
 	HCERTSTORE hStore = CertOpenStore(CERT_STORE_PROV_SYSTEM,0,0, CERT_SYSTEM_STORE_CURRENT_USER , CertStore);
 
-	// Find start of base 64 encoded cert.
-	char *pStartCert = strstr(Cert,"\r\n"); pStartCert+=2; // Find the start of the cert.
-
+	char *pStartCert = NULL;
+	
 	// XXX: Use better buffer size calculator. 
 	DWORD certLen = strlen(Cert);
 	DWORD cbDecodeLen = certLen  * 2;
@@ -436,6 +439,20 @@
 		goto done;
 	}
 
+	// Find start of base 64 encoded cert.
+	// First, skip to the begin of the certificate(s).
+	pStartCert=strstr(Cert,"-----BEGIN");
+	// Then, go to the next line. This should work for both Unix and DOS formats.
+	if (pStartCert) pStartCert=strstr(pStartCert,"\n"); 
+	if ((!pStartCert) || ((DWORD)(pStartCert-Cert) >= certLen))
+	{
+		// No next line found or at end of file
+		OUTPUT("Malformed cert file\n");
+		ret = FALSE;
+		goto done;
+	}
+	pStartCert++;
+	
 	err = Base64DecodeExA (pStartCert,certLen, pDecodedCert,&cbDecodeLen,&cbDecodeLen) ;
 	if ( err) 
 	{
@@ -502,7 +519,7 @@
 }
 
 
-
+/* We won't be getting certs from webservers!
 // mallocs the B64 Cert, upto someone else to free
 BOOL GetCertFromWebServer(TCHAR *Server, TCHAR *Page ,char **pB64Cert)
 {
@@ -576,6 +593,7 @@
 	if (hSession) lpInternetCloseHandle(hSession);
 	return ret;
 }
+*/
 
 // Generates a Key and the  container if necassary
 // Behavior:
@@ -584,9 +602,13 @@
 // Returns 1 if success 
 //         0 if failure.
 //
-BOOL CreateKeyAndGetContext  (CRYPT_KEY_PROV_INFO *pKeyProvInfo, HCRYPTPROV*  phCryptProv) 
+BOOL CreateKeyAndGetContext  (CRYPT_KEY_PROV_INFO *pKeyProvInfo, HCRYPTPROV*  phCryptProv, TCHAR* gKeyFile) 
 {
 	HCRYPTKEY  hCurKey= 0;
+	FILE *hSource;
+	DWORD dwMagic, dwKeytype, dwEncrypted, dwSaltlen, dwKeyBlobLen;
+	PBYTE pbKeyBlob = NULL; 
+	int error=0;
 
 	BOOL bWorked,ret=TRUE;
 	*phCryptProv = 0; // Start by setting it to 0.
@@ -628,33 +650,108 @@
 
 	//
 	// Check if a key already exisis, 
-	//If it don't generate a key!
 	///////////////////////////////////////////
 	if (!CryptGetUserKey(*phCryptProv,pKeyProvInfo->dwKeySpec,&hCurKey))
 	{
-		int error = GetLastError();
+		error = GetLastError();
 		// Make sure error is no key.
 		if (error != NTE_NO_KEY) 
 		{
-			OUTPUT_1_ARG("First Call to CryptGenKey Failed- with error other than NTE_NO_KEY: [0x%X]\n",error);
+			OUTPUT_1_ARG("CryptGetUserKey Failed- with error other than NTE_NO_KEY: [0x%X]\n",error);
 			ret=FALSE;
 			goto done;
 		}
+	}
 
-		// If key doesn't exist create the key.
+	if(!(hSource = _tfopen(gKeyFile,_T("rb")))) 
+	{
+		OUTPUT_1_ARG("Could not open keyfile %s\n", gKeyFile);
+		ret=FALSE;
+		goto done;
+	}
+
+	// Read MAGIC from source file 
+	fread(&dwMagic, sizeof(DWORD), 1, hSource);
+	if (dwMagic != 0xb0b5f11e) {
+		OUTPUT("Keyfile is not in PVK format\n");
+		ret=FALSE;
+		goto done;
+	}
+
+	// Parse PVK file (see http://www.drh-consultancy.demon.co.uk/pvk.html)
+	// Read an (unknown) reserved word from source file
+	fread(&dwMagic, sizeof(DWORD), 1, hSource);
+	// Read KEYTYPE from source file 
+	fread(&dwKeytype, sizeof(DWORD), 1, hSource);
+	if (dwKeytype != pKeyProvInfo->dwKeySpec)
+	{
+		OUTPUT("Private key type differs from DW_KEY_SPEC\n");
+		ret=FALSE;
+		goto done;
+	}
+	// Read ENCRYPTED from source file 
+	fread(&dwEncrypted, sizeof(DWORD), 1, hSource);
+	// Read SALTLEN from source file 
+	fread(&dwSaltlen, sizeof(DWORD), 1, hSource);
+	if ((dwEncrypted == 1) || (dwSaltlen != 0))
+	{
+		OUTPUT("Private key is encrypted: not supported\n");
+		ret=FALSE;
+		goto done;
+	}
+			
+	// Read key BLOB length from source file, and allocate memory. 
+	fread(&dwKeyBlobLen, sizeof(DWORD), 1, hSource); 
+	if(ferror(hSource) || feof(hSource))
+	{
+		error = GetLastError();
+		OUTPUT_1_ARG("Error reading file header (1)! [%x] \n",error);
+		ret=FALSE;
+		goto done;
+	}
+	if(!(pbKeyBlob = (BYTE *)malloc(dwKeyBlobLen)))
+	{			
+		error = GetLastError();
+		OUTPUT_1_ARG("Memory allocation error. [%x] \n",error);
+		ret=FALSE;
+		goto done;		
+	}
+	//--------------------------------------------------------------------
+	// Read key BLOB from source file. 
+
+	fread(pbKeyBlob, 1, dwKeyBlobLen, hSource); 
+	if(ferror(hSource) || feof(hSource))
+	{			 
+		error = GetLastError();
+		OUTPUT_1_ARG("Error reading file header! (2) [%x] \n",error);
+		ret=FALSE;
+		goto done;			
+	}
+	//--------------------------------------------------------------------
+	// Import key BLOB into CSP. 
+	if(!CryptImportKey(*phCryptProv, pbKeyBlob, dwKeyBlobLen, 0, pKeyProvInfo->dwFlags, &hCurKey))
+	{
+		OUTPUT_1_ARG("Error during CryptImportKey! [%x] \n",error);
+		ret=FALSE;
+		goto done;
+	} 
+
+/* Private key is read from file, not generated on the device!
 		if (!CryptGenKey(*phCryptProv, pKeyProvInfo->dwKeySpec, pKeyProvInfo->dwFlags, &hCurKey))
 		{
 			OUTPUT_1_ARG("Second Call to Error: CryptGenKey Failed [%x] \n",error);
 			ret=FALSE;
 			goto done;
 		}
+*/
 
-	}
 done:
 	if (hCurKey) CryptDestroyKey(hCurKey);
+	if (hSource) fclose(hSource);
 	return ret;
 }
 
+/* We won't be doing cert requests!
 // Builds the CertRequest
 // This char* will need to be freed.
 // Returns 0 if there was some sort of error.
@@ -747,7 +844,7 @@
 int  SendCertRequestToWebServer(TCHAR *server ,TCHAR *page, TCHAR *userName, TCHAR *password, char * PutRequest)
 {
 	TCHAR hdrs[] = _T("Content-Type: application/x-www-form-urlencoded"); // Necessary.
-	TCHAR accept[] = _T("Accept: */*");
+	TCHAR accept[] = _T("Accept: *\/*");
 	TCHAR *acArray[2] = {accept,0};
 	DWORD cbBytesRead,dwErrorCode,dwError;
 	BOOL bWorked;
@@ -1093,7 +1190,9 @@
 
 	return TRUE;
 }
+*/
 
+/* We won't be using WinInet!
 // Does the link to Wininet and sets up the global variables.
 // It's up to the application to free the HINSTANCE
 // returns  0 if error.
@@ -1136,4 +1235,4 @@
 		return 0 ;
 	}
 	return winInet;
-}
+} */
